#include <Array.au3>
#include <ButtonConstants.au3>
#include <Crypt.au3>
#include <Date.au3>
#include <DateTimeConstants.au3>
#include <File.au3>
#include <FileOperations.au3>
#include <Encoding.au3>
#include <GUIConstantsEx.au3>
#include <INet.au3>
#include "IniString.au3"
#include "_ViewValues.au3"
#include <WindowsConstants.au3>
#include <Excel.au3>
#include <EditConstants.au3>
#include 'GUICtrlRegExpRestrict.au3'
#include <GUIListBox.au3>
#include <StaticConstants.au3>
#include <ListviewConstants.au3>
#include <Constants.au3>
#include <ComboConstants.au3>
#include <GuiComboBox.au3>
#include <GuiImageList.au3>
#include <GuiListView.au3>
#include <WinAPIRes.au3>
#include <WinAPI.au3>
#include <WinAPIDiag.au3>
#include '_StringUDec2Bin.au3' ;      
#include '_StringUBin2Dec.au3' ;      

Global  $IC_WINVER=_IC_WinVer()
Global $sTextForTheme= StringSplit(" |  1|  2| |    ","|"), $Path, $hList1

_form_switchview()

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
	EndSwitch
WEnd

Func _form_switchview()
	$Form5 = GUICreate("SwitchViewTC", 540, 355, -1, -1, BitOR($WS_CAPTION, $WS_SYSMENU), $WS_EX_TOPMOST)
	$hList1 = GUICtrlCreateList("", 8, 56, 209, 270)
		GUICtrlSetData($hList1, 'PowerUser')
		_GUICtrlListBox_SetCurSel($hList1, 0)
		_SelectView(@ScriptDir)
	GUISetState(@SW_SHOW)
EndFunc

Func _SelectView($Path)
	Local $hLVI[300] = [299], $Item[7] = [6], $hList1, $hLV

	$sPath = $Path & "\PowerUser\Color.ini"
	$BackColor = IniRead($sPath, "Colors", "BackColor", "") ;;  
	$BackColor2 = IniRead($sPath, "Colors", "BackColor2", "") ;;   2
	$ForeColor = IniRead($sPath, "Colors", "ForeColor", "") ;;  
	$MarkColor = IniRead($sPath, "Colors", "MarkColor", "")
	$CurTextColor = IniRead($sPath, "Colors", "CursorText", "") ;;    

	If $CurTextColor = '-1' Then $CurTextColor = $BackColor
	If $MarkColor = "-1" Then $MarkColor = "255"

	$CursorColor = IniRead($sPath, "Colors", "CursorColor", "") ;;  
	$ThemedCursor = IniRead($sPath, "Colors", "ThemedCursor", "") ;;    Windows
	$InverseCursor = IniRead($sPath, "Colors", "InverseCursor", "") ;;  
	$InverseSel = IniRead($sPath, "Colors", "InverseSelection", "") ;;  
	$BGRBackColor = StringFormat("%06X", $BackColor)
	$BGRBackColor2 = StringFormat("%06X", $BackColor2)
	$BGRForeColor = StringFormat("%06X", $ForeColor)
	$BGRMarkColor = StringFormat("%06X", $MarkColor)
	$BGRCurTextColor = StringFormat("%06X", $CurTextColor)
	$BGRCursorColor = StringFormat("%06X", $CursorColor)
	$hLV = GUICtrlCreateListView(' ', 220, 56, 312, 235, $LVS_REPORT)
		_GUICtrlListView_SetExtendedListViewStyle($hLV, BitOR($LVS_EX_DOUBLEBUFFER, $LVS_EX_FULLROWSELECT, $WS_EX_CLIENTEDGE, $LVS_EX_BORDERSELECT))
		_IC_SetExplorerStyle($hLV)
		_GUICtrlListView_SetColumnWidth($hLV, 0, 310)
		GUICtrlSetBkColor($hLV, $GUI_BKCOLOR_LV_ALTERNATE)
		GUICtrlSetBkColor($hLV, "0x" & StringRegExpReplace($BGRBackColor, '(..)(..)(..)', '$3$2$1'))
		For $i = 1 To $sTextForTheme[0]
			$hLVI[$i] = GUICtrlCreateListViewItem($sTextForTheme[$i], $hLV)
			If $BackColor2 <> "-1" Then GUICtrlSetBkColor($hLVI[$i], "0x" & StringRegExpReplace($BGRBackColor2, '(..)(..)(..)', '$3$2$1'))
			If $i = "1" Or $i = "3" Or $i = "5" And $BackColor2 <> "-1" Then GUICtrlSetBkColor($hLVI[$i], "0x" & StringRegExpReplace($BGRBackColor2, '(..)(..)(..)', '$3$2$1'))
			GUICtrlSetColor($hLVI[$i], "0x" & StringRegExpReplace($BGRForeColor, '(..)(..)(..)', '$3$2$1'))

			If $InverseCursor = "1" Then
;           windows    
				GUICtrlSetBkColor($hLVI[4], "0x" & StringRegExpReplace($BGRCursorColor, '(..)(..)(..)', '$3$2$1'))
				GUICtrlSetColor($hLVI[4], "0x" & StringRegExpReplace($BGRCurTextColor, '(..)(..)(..)', '$3$2$1'))
				GUICtrlSetBkColor($hLVI[5], "0x" & StringRegExpReplace($BGRCursorColor, '(..)(..)(..)', '$3$2$1'))
				GUICtrlSetColor($hLVI[5], "0x" & StringRegExpReplace($BGRCurTextColor, '(..)(..)(..)', '$3$2$1'))
			Else
			
			EndIf

			If $InverseSel = "0" Then
				GUICtrlSetColor($hLVI[5], "0x" & StringRegExpReplace($BGRMarkColor, '(..)(..)(..)', '$3$2$1'))
			Else
				GUICtrlSetColor($hLVI[5], "0x" & StringRegExpReplace($BGRCurTextColor, '(..)(..)(..)', '$3$2$1'))
				GUICtrlSetBkColor($hLVI[5], "0x" & StringRegExpReplace($BGRMarkColor, '(..)(..)(..)', '$3$2$1'))
			EndIf

;               Windows
			Switch $ThemedCursor
				Case ''

				Case '0'

				Case '1'
					_GUICtrlListView_SetItemSelected($hLV, 3)
					_GUICtrlListView_SetItemSelected($hLV, 4)
			EndSwitch
; InverseCursor=0 -   
;  ,      CursorColor.         Windows,   
;        .
		Next
 ; GUICtrlSetStyle($hLV, BitOR($WS_DISABLED, $LVS_REPORT, $WS_EX_CLIENTEDGE,$LVS_EX_BORDERSELECT ))
EndFunc   ;==>_SelectView

Func _IC_SetExplorerStyle($hWnd)
	$hWnd = IsHWnd($hWnd) ? $hWnd : GUICtrlGetHandle($hWnd)
	If $hWnd And $IC_WINVER >= 1536 Then
		$aRet = DllCall('uxtheme.dll', 'uint', 'SetWindowTheme', "hwnd", $hWnd, 'wstr', 'Explorer', 'ptr', 0)
		If Not @error And Not $aRet[0] Then Return 1
	EndIf
	Return
EndFunc   ;==>_IC_SetExplorerStyle

Func _IC_WinVer()
	Local $fLine = DllStructCreate('dword OSVersionInfoSize;dword MajorVersion;dword MinorVersion;dword BuildNumber;dword PlatformId;wchar CSDVersion[128]'), $0 = DllStructSetData($fLine, 'OSVersionInfoSize', DllStructGetSize($fLine)), $Ret = DllCall('kernel32.dll', 'int', 'GetVersionExW', 'ptr', DllStructGetPtr($fLine))
	Return (Not @error And $Ret[0]) ? BitOR(BitShift(DllStructGetData($fLine, 'MajorVersion'), -8), DllStructGetData($fLine, 'MinorVersion')) : 0
EndFunc   ;==>_IC_WinVer